/******************************************************************************
 *    (c)2010-2012 Broadcom Corporation
 *
 * This program is the proprietary software of Broadcom Corporation and/or its licensors,
 * and may only be used, duplicated, modified or distributed pursuant to the terms and
 * conditions of a separate, written license agreement executed between you and Broadcom
 * (an "Authorized License").  Except as set forth in an Authorized License, Broadcom grants
 * no license (express or implied), right to use, or waiver of any kind with respect to the
 * Software, and Broadcom expressly reserves all rights in and to the Software and all
 * intellectual property rights therein.  IF YOU HAVE NO AUTHORIZED LICENSE, THEN YOU
 * HAVE NO RIGHT TO USE THIS SOFTWARE IN ANY WAY, AND SHOULD IMMEDIATELY
 * NOTIFY BROADCOM AND DISCONTINUE ALL USE OF THE SOFTWARE.
 *
 * Except as expressly set forth in the Authorized License,
 *
 * 1.     This program, including its structure, sequence and organization, constitutes the valuable trade
 * secrets of Broadcom, and you shall use all reasonable efforts to protect the confidentiality thereof,
 * and to use this information only in connection with your use of Broadcom integrated circuit products.
 *
 * 2.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, THE SOFTWARE IS PROVIDED "AS IS"
 * AND WITH ALL FAULTS AND BROADCOM MAKES NO PROMISES, REPRESENTATIONS OR
 * WARRANTIES, EITHER EXPRESS, IMPLIED, STATUTORY, OR OTHERWISE, WITH RESPECT TO
 * THE SOFTWARE.  BROADCOM SPECIFICALLY DISCLAIMS ANY AND ALL IMPLIED WARRANTIES
 * OF TITLE, MERCHANTABILITY, NONINFRINGEMENT, FITNESS FOR A PARTICULAR PURPOSE,
 * LACK OF VIRUSES, ACCURACY OR COMPLETENESS, QUIET ENJOYMENT, QUIET POSSESSION
 * OR CORRESPONDENCE TO DESCRIPTION. YOU ASSUME THE ENTIRE RISK ARISING OUT OF
 * USE OR PERFORMANCE OF THE SOFTWARE.
 *
 * 3.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, IN NO EVENT SHALL BROADCOM OR ITS
 * LICENSORS BE LIABLE FOR (i) CONSEQUENTIAL, INCIDENTAL, SPECIAL, INDIRECT, OR
 * EXEMPLARY DAMAGES WHATSOEVER ARISING OUT OF OR IN ANY WAY RELATING TO YOUR
 * USE OF OR INABILITY TO USE THE SOFTWARE EVEN IF BROADCOM HAS BEEN ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGES; OR (ii) ANY AMOUNT IN EXCESS OF THE AMOUNT
 * ACTUALLY PAID FOR THE SOFTWARE ITSELF OR U.S. $1, WHICHEVER IS GREATER. THESE
 * LIMITATIONS SHALL APPLY NOTWITHSTANDING ANY FAILURE OF ESSENTIAL PURPOSE OF
 * ANY LIMITED REMEDY.
 *
 *****************************************************************************/


/* This file has been auto-generated by the Broadcom DirectFB Makefile - do NOT delete! */
#ifndef __BCMNEXUS_IR_INPUTMODE_H__
#define __BCMNEXUS_IR_INPUTMODE_H__

#include <strings.h>

typedef enum DFB_PlatformIrInputMode
{
    DFB_PlatformIrInputMode_eTwirpKbd,
    DFB_PlatformIrInputMode_eSejin38KhzKbd,
    DFB_PlatformIrInputMode_eSejin56KhzKbd,
    DFB_PlatformIrInputMode_eRemoteA,
    DFB_PlatformIrInputMode_eRemoteB,
    DFB_PlatformIrInputMode_eCirGI,
    DFB_PlatformIrInputMode_eCirSaE2050,
    DFB_PlatformIrInputMode_eCirTwirp,
    DFB_PlatformIrInputMode_eCirSony,
    DFB_PlatformIrInputMode_eCirRecs80,
    DFB_PlatformIrInputMode_eCirRc5,
    DFB_PlatformIrInputMode_eCirUei,
    DFB_PlatformIrInputMode_eCirRfUei,
    DFB_PlatformIrInputMode_eCirEchoStar,
    DFB_PlatformIrInputMode_eSonySejin,
    DFB_PlatformIrInputMode_eCirNec,
    DFB_PlatformIrInputMode_eCirRC6,
    DFB_PlatformIrInputMode_eCirGISat,
    DFB_PlatformIrInputMode_eCustom,
    DFB_PlatformIrInputMode_eCirDirectvUhfr,
    DFB_PlatformIrInputMode_eCirEchostarUhfr,
    DFB_PlatformIrInputMode_eCirRcmmRcu,
    DFB_PlatformIrInputMode_eCirRstep,
    DFB_PlatformIrInputMode_eCirXmp,
    DFB_PlatformIrInputMode_eCirXmp2Ack,
    DFB_PlatformIrInputMode_eCirRC6Mode0,
    DFB_PlatformIrInputMode_eCirRca,
    DFB_PlatformIrInputMode_eCirToshibaTC9012,
    DFB_PlatformIrInputMode_eMax
} DFB_PlatformIrInputMode;

#define DFB_PlatformIrInputMode_eMin     DFB_PlatformIrInputMode_eTwirpKbd 

static const char *DFB_PlaformIrInputModeName_Table[] = 
{
    [DFB_PlatformIrInputMode_eTwirpKbd] = "TwirpKbd",
    [DFB_PlatformIrInputMode_eSejin38KhzKbd] = "Sejin38KhzKbd",
    [DFB_PlatformIrInputMode_eSejin56KhzKbd] = "Sejin56KhzKbd",
    [DFB_PlatformIrInputMode_eRemoteA] = "RemoteA",
    [DFB_PlatformIrInputMode_eRemoteB] = "RemoteB",
    [DFB_PlatformIrInputMode_eCirGI] = "CirGI",
    [DFB_PlatformIrInputMode_eCirSaE2050] = "CirSaE2050",
    [DFB_PlatformIrInputMode_eCirTwirp] = "CirTwirp",
    [DFB_PlatformIrInputMode_eCirSony] = "CirSony",
    [DFB_PlatformIrInputMode_eCirRecs80] = "CirRecs80",
    [DFB_PlatformIrInputMode_eCirRc5] = "CirRc5",
    [DFB_PlatformIrInputMode_eCirUei] = "CirUei",
    [DFB_PlatformIrInputMode_eCirRfUei] = "CirRfUei",
    [DFB_PlatformIrInputMode_eCirEchoStar] = "CirEchoStar",
    [DFB_PlatformIrInputMode_eSonySejin] = "SonySejin",
    [DFB_PlatformIrInputMode_eCirNec] = "CirNec",
    [DFB_PlatformIrInputMode_eCirRC6] = "CirRC6",
    [DFB_PlatformIrInputMode_eCirGISat] = "CirGISat",
    [DFB_PlatformIrInputMode_eCustom] = "Custom",
    [DFB_PlatformIrInputMode_eCirDirectvUhfr] = "CirDirectvUhfr",
    [DFB_PlatformIrInputMode_eCirEchostarUhfr] = "CirEchostarUhfr",
    [DFB_PlatformIrInputMode_eCirRcmmRcu] = "CirRcmmRcu",
    [DFB_PlatformIrInputMode_eCirRstep] = "CirRstep",
    [DFB_PlatformIrInputMode_eCirXmp] = "CirXmp",
    [DFB_PlatformIrInputMode_eCirXmp2Ack] = "CirXmp2Ack",
    [DFB_PlatformIrInputMode_eCirRC6Mode0] = "CirRC6Mode0",
    [DFB_PlatformIrInputMode_eCirRca] = "CirRca",
    [DFB_PlatformIrInputMode_eCirToshibaTC9012] = "CirToshibaTC9012",
};

static inline DFB_PlatformIrInputMode DFB_PlatformLookupIrInputmode (const char* name) {
    DFB_PlatformIrInputMode inputMode;
    for (inputMode = DFB_PlatformIrInputMode_eMin; inputMode < DFB_PlatformIrInputMode_eMax; inputMode++)
    { 
        if (strcasecmp(name, DFB_PlaformIrInputModeName_Table[inputMode]) == 0)
            return inputMode;
    }

    return DFB_PlatformIrInputMode_eMax;
}
#endif /* __BCMNEXUS_IR_INPUTMODE_H__ */
